
; *****************************************************************************
;               Instalace eskch znak na displej EGA/VGA V2.00
; *****************************************************************************
code     segment
         assume    cs:code,ds:code
         org       100h

start:   jmp       instal                   ; instalace programu

old10    dd        0                        ; pvodn adresa obsluhy INT 10h

identtop label     byte                     ; zatek identifikace programu
         db        'EGACS V2.10'
identend label     byte                     ; konec identifikace

; -----------------------------------------------------------------------------
;        Obsluha peruen INT 10h
; -----------------------------------------------------------------------------
public   int10i
int10i:                                   ;* voln pvodn obsluhy INT 10h
         pushf                              ; simulace isntrukce INT xx
         call      dword ptr cs:[old10]     ; nastaven novho videomdu
         ret
; -----------------------------------------------------------------------------
public   int10
int10:                                      ; obsluha displeje INT 10h
                                          ;* je dotaz na instalaci ?
         cmp       ax,1130h                 ; funkce informac o fontech ?
         jne       int101                   ; nejsou informace o fontech
         cmp       bx,5678h                 ; identifikace dotazu ?
         jne       int101                   ; nen identifikace dotazu
         call      int10i                   ; proveden obsluhy
         push      cs
         pop       es                       ; segment rezidentn sti
         iret

int101:  cmp       byte ptr cs:[disable],0  ; je obsluha povolen ?
         jne       int102                   ; obsluha je zakzan
         or        ah,ah                    ; je nastaven mdu displeje ?
         jz        int103                   ; je nastaven videomdu
         cmp       ah,11h
         jne       int102                   ; nen operace s fonty
                                          ;* je sluba 11h - nastaven font
         cmp       al,1
         je        int103                   ; naten fontu 8x14
         cmp       al,2
         je        int103                   ; naten fontu 8x8
         cmp       al,4
         je        int103                   ; naten fontu 8x16
         cmp       al,11h
         je        int103                   ; naten fontu 8x14
         cmp       al,12h
         je        int103                   ; naten fontu 8x8
         cmp       al,14h
         je        int103                   ; naten fontu 8x16
         cmp       al,22h
         je        int103                   ; naten graf. fontu 8x14
         cmp       al,23h
         je        int103                   ; naten graf. fontu 8x8
         cmp       al,24h
         je        int103                   ; naten graf. fontu 8x16
int102:  jmp       dword ptr cs:[old10]     ; skok na pvodn obsluhu INT 10h

int103:                                   ;* nastaven eskho videomdu
         inc       byte ptr cs:[disable]    ; blokovn funkce
         call      int10i                   ; voln poadovan funkce
         sti                                ; povolen peruen
         push      ax
         push      bx
         push      cx
         push      dx
         push      si
         push      di
         push      bp
         push      ds
         push      es


         xor       ax,ax
         mov       ds,ax                    ; DS <- 0 datov segment BIOS
         push      cs
         pop       es                       ; ES <- CS tento segment programu

                                          ;* schova nastaven displeje
         mov       ah,0fh
         call      int10i                   ; poskytnut aktivn strnky
         mov       ah,3
         call      int10i                   ; ten pozice a velikosti kurzoru
         push      cx                       ; schova rozmr kurzoru
         push      bx                       ; schova aktivn strnky
         push      dx                       ; schova pozice kurzoru
         push      word ptr ds:[44ch]       ; schova velikosti bufferu


         mov       bh,ds:[485h]             ; poet linek na znak
         call      loadfont                 ; naten standardnho fontu
         jc        int109                   ; font nen definovn

         call      defin                    ; definovn nrodnch font
         jc        int109                   ; font nen definovn

                                          ;* nastaven pro textov md
         mov       al,10h                   ; pkaz pro naten uiv. font
         mov       cx,256                   ; poet znak
         xor       dx,dx                    ; offset zatku tabulky

                                          ;* je textov md ?
         mov       ah,ds:[449h]             ; aktivn videomd
         and       ah,7fh
         cmp       ah,3
         jbe       int10d                   ; je textov md
         cmp       ah,7
         je        int10d                   ; je MDA md

                                          ;* je grafick videomd
         mov       cx,cs:[adrbuff]          ; adresa bufferu
         add       cx,128*8                 ; povolovina bufferu
         mov       ds:[7ch],cx              ; fonty pro INT 1fh
         mov       word ptr ds:[7ch+2],cs
         xor       cx,cx
         mov       cl,bh                    ; poet linek na znak
         mov       dl,ds:[484h]             ; slo poslednho dku
         inc       dl                       ; poet dk
         mov       al,21h

                                          ;* definice font
int10d:  mov       ah,11h
         xor       bl,bl                    ; blok fontu 0, poet dk v DL
         mov       bp,cs:[adrbuff]          ; adresa bufferu s fontem
         call      int10i                   ; naten uivatelskch font
int109:
                                          ;* navrcen parametr displeje
         mov       cx,cs:[adrbuff]          ; adresa bufferu
         mov       ds:[43h*4],cx
         mov       ds:[43h*4+2],cs

         pop       word ptr ds:[44ch]       ; schova velikosti bufferu
         pop       dx                       ; nvrat pozice kurzoru
         pop       bx                       ; nvrat aktivn strnky
         mov       ah,2
         call      int10i                   ; nvrat pozice kurzoru
         pop       cx                       ; nvrat velikosti kurzoru
         mov       ah,1
         call      int10i                   ; nvrat rozmr kurzoru

         pop       es
         pop       ds
         pop       bp
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         dec       byte ptr cs:[disable]     ; povolen obsluhy
         iret

; -----------------------------------------------------------------------------
public   loadfont
                                          ;* naten standardnho fontu
                                            ; VSTUP: BH=poet linek na znak
                                            ;        ES=tento segment
                                            ; VSTUP: CY=font nen definovn
                                            ;         SI=adresa vlastnho fontu

                                          ;* nalezen tabulky fontu
loadfont:mov       si,offset fonty          ; tabulky font
         mov       cx,4                     ; poet monch font
loadfnt1:cmp       cs:[si],bh               ; souhlas poet linek na znak ?
         je        loadfnt2                 ; poadovan font nalezen
         add       si,7                     ; adresa dal tabulky
         loop      loadfnt1                 ; test dalho fontu
         stc                                ; pznak chyby - font nenalezen
         ret

                                          ;* tabulka nalezena - naten
loadfnt2:push      ds
         push      si
         xor       cx,cx
         mov       ch,bh                    ; dlka tabulky
         shr       cx,1                     ; dlka tabulky / 2
         lds       si,cs:[si+1]             ; adresa systmovho fontu
         mov       di,cs:[adrbuff]          ; buffer k naten fontu
         cld
         rep       movsw                    ; penos fontu do bufferu
         pop       si
         pop       ds
         mov       si,cs:[si+5]             ; adresa vlastnho fontu
         clc                                ; pznak operace OK
         ret

; -----------------------------------------------------------------------------
public   defin
defin:                                    ;* definovn nrodnch font
                                            ; VSTUP: SI=offset adresy fontu
                                            ;        ES=tento segment
                                            ;        BH=poet bajt na znak
                                            ; VSTUP: CY=kd nen definovn

         push      bx
         push      ds
         push      cs
         pop       ds

         mov       di,cs:[adrbuff]          ; buffer s fonty
         xor       cx,cx                    ; CX <- 0
         mov       cl,bh                    ; poet bajt na znak

                                          ;* adresa definin tabulky
         xor       bx,bx                    ; BX <- 0
         mov       bl,ds:[font]             ; slo fontu
         cmp       bl,4                     ; je font vt ne 4 ?
         cmc                                ; CY = chyba
         jb        defin5                   ; nepovolen slo fontu
         add       bx,bx                    ; slo fontu * 2
         add       bx,offset tables         ; adresa definin tabulky
         mov       bx,ds:[bx]               ; adresa definin tabulky

                                          ;* test konce tabulky
defin1:  mov       al,cs:[bx]               ; povel z definin tabulky
         inc       bx                       ; zven ukazatele v defin. tabulce
         or        al,al                    ; je konec tabulky ?
         jz        defin5                   ; konec tabulky

                                          ;* peskoen znak
         js        defin2                   ; je penos znaku
         mul       cl                       ; prustek adresy
         add       di,ax                    ; zven adresy o AL znak
         jmp       short defin1             ; dal bajt

                                          ;* penos znaku z vlastn tabulky
defin2:  and       al,7fh
         mul       cl                       ; vpoet offsetu v tabulce
         push      si
         add       si,ax                    ; poten adresa znaku v tabulce
         push      cx
         cld
         rep       movsb                    ; penesen znaku
         pop       cx
         pop       si                       ; nvrat adresy tabulky font
         jmp       short defin1             ; dal bajt

defin5:  pop       ds
         pop       bx
         ret


; ******************** pedefinovateln tabulky, data *************************


adrbuff  dw        0                        ; adresa bufferu

font     db        0                        ; slo fontu (0ffh=standardn)
                                            ;       0 = Kamenickch
                                            ;       1 = Latin 2
                                            ;       2 = KOI 8
disable  db        0                        ; blokovn funkce (0=povoleno)


fonty    label     byte                   ;* adresy font
         db        8                        ; poet linek na znak = 8
         dd        0                        ; adresa standardnho fontu 8x8
         dw        offset font8             ; adresa vlastnho fontu 8x8

         db        14                       ; poet linek na znak = 14
         dd        0                        ; adresa standardnho fontu 8x14
         dw        offset font14            ; adresa vlastnho fontu 8x14

tabfnt16 db        16                       ; poet linek na znak = 16
         dd        0                        ; adresa standardnho fontu 8x16
         dw        offset font16            ; adresa vlastnho fontu 8x16

         db        0
         dd        0                        ; rezerva
         dw        0                        ; rezerva

tables   label     byte                     ; definin tabulky font
         dw        offset tabkam            ; tabulka Kamenickch
         dw        offset tablat            ; tabulka Latin 2
         dw        offset tabkoi            ; tabulka KOI 8
         dw        0                        ; rezerva


; Definice struktury fontu (definin tabulka):
;
;  00000000b - konec tabulky
;  0xxxxxxxb - peskoen xxxxxxxb znak (1 a 127)
;  1xxxxxxxb - pouije se znak xxxxxxxb z vlastn tabulky (0 a 127)


tabkam   label     byte                     ; definin tabulka Kamenickch

         db        127
         db        1
         db        xc3                      ; 128 ""
         db        2
         db        xd2                      ; 131 ""
         db        1
         db        xd1                      ; 133 ""
         db        xt1                      ; 134 ""
         db        xc4                      ; 135 ""
         db        xe3                      ; 136 ""
         db        xe2                      ; 137 ""
         db        xl1                      ; 138 ""
         db        xi1                      ; 139 ""
         db        xl4                      ; 140 ""
         db        xl2                      ; 141 ""
         db        1
         db        xa1                      ; 143 ""
         db        xe1                      ; 144 ""
         db        xz4                      ; 145 ""
         db        xz3                      ; 146 ""
         db        2
         db        xo1                      ; 149 ""
         db        xu3                      ; 150 ""
         db        xu1                      ; 151 ""
         db        xy2                      ; 152 ""
         db        2
         db        xs3                      ; 155 ""
         db        xl3                      ; 156 ""
         db        xy1                      ; 157 ""
         db        xr3                      ; 158 ""
         db        xt2                      ; 159 ""
         db        4
         db        xn4                      ; 164 ""
         db        xn3                      ; 165 ""
         db        xu2                      ; 166 ""
         db        xo2                      ; 167 ""
         db        xs4                      ; 168 ""
         db        xr4                      ; 169 ""
         db        xr2                      ; 170 ""
         db        xr1                      ; 171 ""
         db        1
         db        xx1                      ; 173 "" paragraf

         db        0                        ; konec tabulky

tablat   label     byte                     ; definin tabulka Latin 2

         db        127
         db        6
         db        xu3                      ; 133 "" s kroukem
         db        xc2                      ; 134 "c" s rkou
         db        1
         db        xl6                      ; 136 "l" pekrtnut
         db        1
         db        xo3                      ; 138 "O" se 2 rkama
         db        xo4                      ; 139 "o" se 2 rkama
         db        1
         db        xz1                      ; 140 "Z" s rkou
         db        1
         db        xc1                      ; 143 "C" s rkou
         db        xe1                      ; 144 "E" s rkou
         db        xl1                      ; 145 "L" s rkou
         db        xl2                      ; 146 "l" s rkou
         db        2
         db        xl3                      ; 149 "L" s hkem
         db        xl4                      ; 150 "l" s hkem
         db        xs1                      ; 151 "S" s rkou
         db        xs2                      ; 152 "s" s rkou
         db        2
         db        xt1                      ; 155 "T" s hkem
         db        xt2                      ; 156 "t" s hkem
         db        xl5                      ; 157 "L" pekrtnut
         db        xx2                      ; 158 pekrtnut
         db        xc4                      ; 159 "c" s hkem
         db        4
         db        xa5                      ; 164 "A" s noikou
         db        xa6                      ; 165 "a" s noikou
         db        xz3                      ; 166 "Z" s hkem
         db        xz4                      ; 167 "z" s hkem
         db        xe5                      ; 168 "E" s noikou
         db        xe6                      ; 169 "e" s noikou
         db        1
         db        xz2                      ; 171 "z" s rkou
         db        xc3                      ; 172 "C" s hkem
         db        xs6                      ; 173 "s" s ocskem
         db        7
         db        xa1                      ; 181 "A" s rkou
         db        xa4                      ; 182 "A" se stkou
         db        xe2                      ; 183 "E" s hkem
         db        xs5                      ; 184 "S" s ocskem
         db        4
         db        xz5                      ; 189 "Z" s tekou
         db        xz6                      ; 190 "z" s tekou
         db        7
         db        xa2                      ; 198 "A" s hkem
         db        xa3                      ; 199 "a" s hkem
         db        7
         db        xx3                      ; 207 "x" s drou
         db        xd4                      ; 208 "d" pekrtnut
         db        xd3                      ; 209 "D" pekrtnut
         db        xd1                      ; 210 "D" s hkem
         db        xe4                      ; 211 "E" pehlasovan
         db        xd2                      ; 212 "d" s hkem
         db        xn3                      ; 213 "N" s hkem
         db        xi1                      ; 214 "I" s rkou
         db        xi2                      ; 215 "I" se stkou
         db        xe3                      ; 216 "e" s hkem
         db        4
         db        xt3                      ; 221 "T" s ocskem
         db        xu2                      ; 222 "U" s kroukem
         db        1
         db        xo1                      ; 224 "O" s rkou
         db        1
         db        xo2                      ; 226 "O" se stkou
         db        xn1                      ; 227 "N" s rkou
         db        xn2                      ; 228 "n" s rkou
         db        xn4                      ; 229 "n" s hkem
         db        xs3                      ; 230 "S" s hkem
         db        xs4                      ; 231 "s" s hkem
         db        xr1                      ; 232 "R" s rkou
         db        xu1                      ; 233 "U" s rkou
         db        xr2                      ; 234 "r" s rkou
         db        xu4                      ; 235 "U" se 2 rkama
         db        xy2                      ; 236 "y" s rkou
         db        xy1                      ; 237 "Y" s rkou
         db        xt4                      ; 238 "t" s ocskem
         db        xx4                      ; 239 "'" rka vpravo
         db        xx5                      ; 240 "-" krtk pomlka
         db        xx6                      ; 241 " 2 rky
         db        xx7                      ; 242 noika
         db        xx8                      ; 243 hek
         db        xx9                      ; 244 miska
         db        xx1                      ; 245 "" paragraf
         db        1
         db        xxa                      ; 247 ocsek
         db        1
         db        xxb                      ; 249 pehlasovn
         db        1
         db        xu5                      ; 251 "u" se 2 rkama
         db        xr3                      ; 252 "R" s hkem
         db        xr4                      ; 253 "r" s hkem

         db        0                        ; konec tabulky

tabkoi   label     byte                     ; definin tabulka KOI 8

         db        0                        ; konec tabulky



font8    label     byte                     ; fonty 8x8
         db        13h,3bh,6ch,0c6h,0feh,0c6h,0c6h,0       ; 0: "" s rkou
xa1      equ       ($-font8)/8 + 7fh
         db        7ch,38h,6ch,0c6h,0feh,0c6h,0c6h,0       ; 2: "A" s hkem
xa2      equ       ($-font8)/8 + 7fh
         db        6ch,38h,7ch,6,7eh,0c6h,7eh,0            ; 3: "a" s hkem
xa3      equ       ($-font8)/8 + 7fh
         db        7ch,38h,6ch,0c6h,0feh,0c6h,0c6h,0       ; 6: "A" se stkou
xa4      equ       ($-font8)/8 + 7fh
         db        38h,6ch,0c6h,0c6h,0feh,0c6h,0ceh,0ch    ; 8: "A" s noikou
xa5      equ       ($-font8)/8 + 7fh
         db        0,0,7ch,6,7eh,0c6h,7eh,18h              ; 9: "a" s noikou
xa6      equ       ($-font8)/8 + 7fh
         db        6,3ch,66h,0c0h,0c0h,66h,3ch,0           ; 10: "C" s rkou
xc1      equ       ($-font8)/8 + 7fh
         db        6,0ch,7ch,0c6h,0c0h,0c6h,7ch,0          ; 11: "c" s rkou
xc2      equ       ($-font8)/8 + 7fh
         db        66h,3ch,66h,0c0h,0c0h,66h,3ch,0         ; 12: "" s hkem
xc3      equ       ($-font8)/8 + 7fh
         db        66h,3ch,7ch,0c6h,0c0h,0c6h,7ch,0        ; 13: "" s hkem
xc4      equ       ($-font8)/8 + 7fh
         db        0cch,78h,0f8h,0cch,0c6h,0cch,0f8h,0     ; 16: "" s hkem
xd1      equ       ($-font8)/8 + 7fh
         db        96h,66h,6,7eh,0c6h,0c6h,7eh,0           ; 17: "" s hkem
xd2      equ       ($-font8)/8 + 7fh
         db        0f8h,06ch,066h,076h,0e6h,06ch,0f8h,0    ; 18: "D" pekrnut
xd3      equ       ($-font8)/8 + 7fh
         db        6,0fh,6,7eh,0c6h,0c6h,7eh,0             ; 19: "d" pekrtnut
xd4      equ       ($-font8)/8 + 7fh
         db        0ch,18h,7eh,60h,78h,60h,7eh,0           ; 20: "" s rkou
xe1      equ       ($-font8)/8 + 7fh
         db        0cch,78h,0fch,0c0h,0f0h,0c0h,0fch,0     ; 22: "" s hkem
xe2      equ       ($-font8)/8 + 7fh
         db        66h,3ch,7ch,0c6h,0feh,0c0h,7ch,0        ; 23: "" s hkem
xe3      equ       ($-font8)/8 + 7fh
         db        66h,0,0feh,0c0h,0f8h,0c0h,0feh,0        ; 24: "E" pehlasovan
xe4      equ       ($-font8)/8 + 7fh
         db        0feh,0c0h,0c0h,0f8h,0c0h,0c0h,0feh,0ch  ; 26: "E" s noikou
xe5      equ       ($-font8)/8 + 7fh
         db        0,0,7ch,0c6h,0feh,0c0h,7ch,0ch          ; 27: "e" s noikou
xe6      equ       ($-font8)/8 + 7fh
         db        0ch,18h,3ch,18h,18h,18h,3ch,0           ; 28: "" s rkou
xi1      equ       ($-font8)/8 + 7fh
         db        7eh,0c3h,3ch,18h,18h,18h,3ch,0          ; 30: "I" se stkou
xi2      equ       ($-font8)/8 + 7fh
         db        3ch,66h,18h,18h,18h,18h,18h,0           ; 31: "i" se stkou
xi3      equ       ($-font8)/8 + 7fh
         db        0cch,0cch,0d8h,0c0h,0c0h,0c0h,0feh,0    ; 32: "" s rkou
xl1      equ       ($-font8)/8 + 7fh
         db        1bh,1bh,18h,18h,18h,18h,18h,0           ; 33: "" s rkou
xl2      equ       ($-font8)/8 + 7fh
         db        0dbh,0ceh,0c0h,0c0h,0c0h,0c0h,0feh,0    ; 34: "" s hkem
xl3      equ       ($-font8)/8 + 7fh
         db        35h,32h,30h,30h,30h,30h,30h,0           ; 35: "" s hkem
xl4      equ       ($-font8)/8 + 7fh
         db        0f0h,060h,060h,070h,0e0h,062h,0feh,0    ; 36: "L" pekrtnut
xl5      equ       ($-font8)/8 + 7fh
         db        18h,18h,18h,1ch,38h,18h,18h,0           ; 37: "l" pektnut
xl6      equ       ($-font8)/8 + 7fh
         db        0deh,0e6h,0f6h,0deh,0ceh,0c6h,0c6h,0    ; 38: "N" s rkou
xn1      equ       ($-font8)/8 + 7fh
         db        06h,0ch,0fch,0c6h,0c6h,0c6h,0c6h,0      ; 39: "n" s rkou
xn2      equ       ($-font8)/8 + 7fh
         db        66h,3ch,0e6h,0f6h,0deh,0ceh,0c6h,0      ; 40: "" s hkem
xn3      equ       ($-font8)/8 + 7fh
         db        6ch,38h,0fch,0c6h,0c6h,0c6h,0c6h,0      ; 41: "" s hkem
xn4      equ       ($-font8)/8 + 7fh
         db        3h,3bh,6ch,0c6h,0c6h,6ch,38h,0          ; 42: "" s rkou
xo1      equ       ($-font8)/8 + 7fh
         db        7ch,82h,38h,6ch,0c6h,6ch,38h,0          ; 44: "" se stkou
xo2      equ       ($-font8)/8 + 7fh
         db        66h,38h,6ch,0c6h,0c6h,6ch,38h,0         ; 48: "O" se 2 rkami
xo3      equ       ($-font8)/8 + 7fh
         db        66h,0,7ch,0c6h,0c6h,0c6h,7ch,0          ; 49: "o" se 2 rkami
xo4      equ       ($-font8)/8 + 7fh
         db        18h,30h,0fch,0c6h,0fch,0c6h,0c6h,0      ; 50: "" s rkou
xr1      equ       ($-font8)/8 + 7fh
         db        18h,30h,0dch,0e6h,0c0h,0c0h,0c0h,0      ; 51: "" s rkou
xr2      equ       ($-font8)/8 + 7fh
         db        0cch,78h,0fch,0c6h,0fch,0c6h,0c6h,0     ; 52: "" s hkem
xr3      equ       ($-font8)/8 + 7fh
         db        0cch,78h,0fch,0c6h,0c0h,0c0h,0c0h,0     ; 53: "" s hkem
xr4      equ       ($-font8)/8 + 7fh
         db        0ch,7eh,0c0h,7ch,6,0c6h,7ch,0           ; 54: "S" s rkou
xs1      equ       ($-font8)/8 + 7fh
         db        06h,0ch,7eh,0c0h,7ch,6,0fch,0           ; 55: "s" s rkou
xs2      equ       ($-font8)/8 + 7fh
         db        24h,7eh,0c0h,7ch,6,0c6h,7ch,0           ; 56: "" s hkem
xs3      equ       ($-font8)/8 + 7fh
         db        66h,3ch,7eh,0c0h,7ch,6,0fch,0           ; 57: "" s hkem
xs4      equ       ($-font8)/8 + 7fh
         db        7ch,0c6h,0c0h,7ch,6,0c6h,7ch,0ch        ; 58: "S" s ocskem
xs5      equ       ($-font8)/8 + 7fh
         db        0,0,7ch,0c0h,7ch,6,0fch,0ch             ; 59: "s" s ocskem
xs6      equ       ($-font8)/8 + 7fh
         db        66h,3ch,7eh,18h,18h,18h,18h,0           ; 60: "" s hkem
xt1      equ       ($-font8)/8 + 7fh
         db        66h,66h,0f4h,60h,60h,66h,3ch,0          ; 61: "" s hkem
xt2      equ       ($-font8)/8 + 7fh
         db        0fch,30h,30h,30h,30h,30h,38h,8          ; 62: "T" s ocskem
xt3      equ       ($-font8)/8 + 7fh
         db        60h,60h,0fch,60h,60h,66h,3ch,0ch        ; 63: "t" s ocskem
xt4      equ       ($-font8)/8 + 7fh
         db        0ch,0dah,0c6h,0c6h,0c6h,0c6h,7ch,0      ; 64: "" s rkou
xu1      equ       ($-font8)/8 + 7fh
         db        18h,0a4h,0dah,0c6h,0c6h,0c6h,7ch,0      ; 66: "" s kroukem
xu2      equ       ($-font8)/8 + 7fh
         db        3ch,66h,3ch,0c6h,0c6h,0c6h,7eh,0        ; 67: "" s kroukem
xu3      equ       ($-font8)/8 + 7fh
         db        0c6h,0,0c6h,0c6h,0c6h,0c6h,7ch,0        ; 70: "U" se 2 rkami
xu4      equ       ($-font8)/8 + 7fh
         db        0c6h,0,0c6h,0c6h,0c6h,0c6h,7eh,0        ; 71: "u" se 2 rkami
xu5      equ       ($-font8)/8 + 7fh
         db        0ch,5ah,66h,3ch,18h,18h,18h,0           ; 72: "" s rkou
xy1      equ       ($-font8)/8 + 7fh
         db        0ch,18h,0c6h,0c6h,0c6h,7eh,6,0fch       ; 73: "" s rkou
xy2      equ       ($-font8)/8 + 7fh
         db        0ch,0feh,0ch,18h,30h,60h,0feh,0         ; 74: "Z" s rkou
xz1      equ       ($-font8)/8 + 7fh
         db        6,0ch,7eh,0ch,18h,30h,7eh,0             ; 75: "z" s rkou
xz2      equ       ($-font8)/8 + 7fh
         db        6ch,0feh,0ch,18h,30h,60h,0feh,0         ; 76: "" s hkem
xz3      equ       ($-font8)/8 + 7fh
         db        66h,3ch,7eh,0ch,18h,30h,7eh,0           ; 77: "" s hkem
xz4      equ       ($-font8)/8 + 7fh
         db        0ch,0feh,0ch,18h,30h,60h,0feh,0         ; 78: "Z" s tekou
xz5      equ       ($-font8)/8 + 7fh
         db        0ch,0,7eh,0ch,18h,30h,7eh,0             ; 79: "z" s tekou
xz6      equ       ($-font8)/8 + 7fh
         db        3ch,60h,38h,6ch,6ch,38h,0ch,78h         ; 80: "" paragraf
xx1      equ       ($-font8)/8 + 7fh
         db        0,0,0c6h,6ch,38h,6ch,0c6h,0             ; 81: "x" pekrtnut
xx2      equ       ($-font8)/8 + 7fh
         db        0,0,0c6h,7ch,48h,7ch,0c6h,0             ; 82: "x" x s drou
xx3      equ       ($-font8)/8 + 7fh
         db        0ch,18h,30h,0,0,0,0,0                   ; 83: "'" rka vpravo
xx4      equ       ($-font8)/8 + 7fh
         db        0,0,0,70h,0,0,0,0                       ; 84: "-" krtk pomlka
xx5      equ       ($-font8)/8 + 7fh
         db        33h,66h,0cch,0,0,0,0,0                  ; 85: " 2 rky
xx6      equ       ($-font8)/8 + 7fh
         db        0,0,0,0,30h,30h,3ch,0                   ; 86: patika
xx7      equ       ($-font8)/8 + 7fh
         db        0,66h,3ch,0,0,0,0,0                     ; 87: hek
xx8      equ       ($-font8)/8 + 7fh
         db        0,0c6h,7ch,0,0,0,0,0                    ; 88: miska
xx9      equ       ($-font8)/8 + 7fh
         db        0,0,0,0,0,30h,18h,70h                   ; 89: ocsek
xxa      equ       ($-font8)/8 + 7fh
         db        0,66h,0,0,0,0,0,0                       ; 91: " " pehlasovn
xxb      equ       ($-font8)/8 + 7fh

font14   label     byte                     ; fonty 8x14
db        3,6,10h,38h,6ch,0c6h,0c6h,0feh,0c6h,0c6h,0c6h,0,0,0        ; 0: "" s rkou
db        0c6h,06ch,10h,38h,6ch,0c6h,0c6h,0feh,0c6h,0c6h,0c6h,0,0,0  ; 2: "A" s hkem
db        0,0,0c6h,7ch,0,78h,0ch,7ch,0cch,0cch,76h,0,0,0             ; 3: "a" s hkem
db        7ch,0c6h,10h,38h,6ch,0c6h,0c6h,0feh,0c6h,0c6h,0c6h,0,0,0   ; 6: "A" se stkou
db        0,0,10h,38h,6ch,0c6h,0c6h,0feh,0c6h,0c6h,0ceh,8,0eh,0      ; 8: "A" s noikou
db        0,0,0,0,0,78h,0ch,7ch,0cch,0cch,76h,10h,1ch,0              ; 9: "a" s noikou
db        6,0ch,3ch,66h,0c2h,0c0h,0c0h,0c0h,0c2h,66h,3ch,0,0,0       ; 10: "C" s rkou
db        0,0ch,18h,30h,0,7ch,0c6h,0c0h,0c0h,0c6h,7ch,0,0,0          ; 11: "c" s rkou
db        66h,3ch,3ch,66h,0c2h,0c0h,0c0h,0c0h,0c2h,66h,3ch,0,0,0     ; 12: "" s hkem
db        0,0,66h,3ch,0,7ch,0c6h,0c0h,0c0h,0c6h,7ch,0,0,0            ; 13: "" s hkem
db        0cch,78h,0f8h,6ch,66h,66h,66h,66h,66h,6ch,0f8h,0,0,0       ; 16: "" s hkem
db        6ch,38h,1ch,0ch,0ch,3ch,6ch,0cch,0cch,0cch,7eh,0,0,0       ; 17: "" s hkem
db        0,0,0f8h,6ch,66h,66h,76h,0e6h,66h,6ch,0f8h,0,0,0           ; 18: "D" pekrnut
db        0,0,0ch,1eh,0ch,3ch,6ch,0cch,0cch,0cch,76h,0,0,0           ; 19: "d" pekrtnut
db        0ch,18h,0feh,66h,62h,68h,78h,68h,62h,66h,0feh,0,0,0        ; 20: "" s rkou
db        66h,3ch,0feh,66h,62h,68h,78h,68h,62h,66h,0feh,0,0,0        ; 22: "" s hkem
db        0,0,66h,3ch,0,7ch,0c6h,0feh,0c0h,0c6h,7ch,0,0,0            ; 23: "" s hkem
db        66h,0,0feh,66h,62h,68h,78h,68h,62h,66h,0feh,0,0,0          ; 24: "E" pehlasovan
db        0,0,0feh,66h,62h,68h,78h,68h,62h,66h,0feh,10h,1ch,0        ; 26: "E" s noikou
db        0,0,0,0,0,7ch,0c6h,0feh,0c0h,0c6h,7ch,10h,1ch,0            ; 27: "e" s noikou
db        0ch,18h,3ch,18h,18h,18h,18h,18h,18h,18h,3ch,0,0,0          ; 28: "" s rkou
db        3ch,66h,0,3ch,18h,18h,18h,18h,18h,18h,3ch,0,0,0            ; 30: "I" se stkou
db        0,18h,3ch,66h,0,38h,18h,18h,18h,18h,3ch,0,0,0              ; 31: "i" se stkou
db        0,6,0f6h,64h,60h,60h,60h,60h,62h,66h,0feh,0,0,0            ; 32: "" s rkou
db        6h,6,74h,30h,30h,30h,30h,30h,30h,30h,78h,0,0,0             ; 33: "" s rkou
db        36h,1ch,0f0h,60h,60h,60h,60h,60h,62h,66h,0feh,0,0,0        ; 34: "" s hkem
db        36h,1ch,70h,30h,30h,30h,30h,30h,30h,30h,78h,0,0,0          ; 35: "" s hkem
db        0,0,0f0h,60h,60h,70h,0e0h,060h,62h,66h,0feh,0,0,0          ; 36: "L" pekrtnut
db        0,0,38h,18h,18h,1ch,38h,18h,18h,18h,3ch,0,0,0              ; 37: "l" pektnut
db        0ch,18h,0c6h,0e6h,0f6h,0feh,0deh,0ceh,0c6h,0c6h,0c6h,0,0,0 ; 38: "N" s rkou
db        0,0ch,18h,30h,0,0dch,66h,66h,66h,66h,66h,0,0,0             ; 39: "n" s rkou
db        0cch,78h,0c6h,0e6h,0f6h,0feh,0deh,0ceh,0c6h,0c6h,0c6h,0,0,0; 40: "" s hkem
db        0,0,66h,3ch,0,0dch,66h,66h,66h,66h,66h,0,0,0               ; 41: "" s hkem
db        6,0ch,38h,6ch,0c6h,0c6h,0c6h,0c6h,0c6h,6ch,38h,0,0,0       ; 42: "" s rkou
db        7ch,0c6h,38h,6ch,0c6h,0c6h,0c6h,0c6h,0c6h,6ch,38h,0,0,0    ; 44: "" se stkou
db        63h,0c6h,0,38h,6ch,0c6h,0c6h,0c6h,0c6h,6ch,38h,0,0,0       ; 48: "O" se 2 rkami
db        0,33h,066h,0cch,0,7ch,0c6h,0c6h,0c6h,0c6h,7ch,0,0,0        ; 49: "o" se 2 rkami
db        0ch,18h,0fch,66h,66h,66h,7ch,6ch,66h,66h,0e6h,0,0,0        ; 50: "" s rkou
db        0,6,0ch,18h,0,0dch,76h,66h,60h,60h,0f0h,0,0,0              ; 51: "" s rkou
db        66h,3ch,0fch,66h,66h,66h,7ch,6ch,66h,66h,0f6h,0,0,0        ; 52: "" s hkem
db        0,0,0cch,78h,0,0dch,76h,66h,60h,60h,0f0h,0,0,0             ; 53: "" s hkem
db        0ch,18h,7ch,0c6h,0c6h,60h,38h,0ch,0c6h,0c6h,7ch,0,0,0      ; 54: "S" s rkou
db        0,0ch,18h,30h,0,7ch,0c6h,70h,1ch,0c6h,7ch,0,0,0            ; 55: "s" s rkou
db        66h,3ch,7ch,0c6h,0c6h,60h,38h,0ch,0c6h,0c6h,7ch,0,0,0      ; 56: "" s hkem
db        0,0,66h,3ch,0,7ch,0c6h,70h,1ch,0c6h,7ch,0,0,0              ; 57: "" s hkem
db        0,0,7ch,0c6h,0c6h,60h,38h,0ch,0c6h,0c6h,7ch,18h,0ch,38h    ; 58: "S" s ocskem
db        0,0,0,0,0,7ch,0c6h,70h,1ch,0c6h,7ch,18h,0ch,38h            ; 59: "s" s ocskem
db        66h,3ch,7eh,7eh,5ah,18h,18h,18h,18h,18h,3ch,0,0,0          ; 60: "" s hkem
db        36h,1ch,10h,30h,30h,0fch,30h,30h,30h,36h,1ch,0,0,0         ; 61: "" s hkem
db        0,0,7eh,7eh,5ah,18h,18h,18h,18h,18h,3ch,18h,0ch,38h        ; 62: "T" s ocskem
db        0,0,10h,30h,30h,0fch,30h,30h,30h,36h,1ch,18h,0ch,38h       ; 63: "t" s ocskem
db        0ch,18h,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,7ch,0,0,0  ; 64: "" s rkou
db        3ch,66h,3ch,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,7ch,0,0,0   ; 66: "" s kroukem
db        0,38h,6ch,38h,0,0cch,0cch,0cch,0cch,0cch,76h,0,0,0         ; 67: "" s kroukem
db        33h,66h,0,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,0c6h,7ch,0,0,0     ; 70: "U" se 2 rkami
db        0,33h,66h,0cch,0,0cch,0cch,0cch,0cch,0cch,76h,0,0,0        ; 71: "u" se 2 rkami
db        0ch,18h,66h,66h,66h,66h,3ch,18h,18h,18h,3ch,0,0,0          ; 72: "" s rkou
db        0,6,0ch,18h,0,0c6h,0c6h,0c6h,0c6h,7eh,6,0ch,0f8h,0         ; 73: "" s rkou
db        0ch,18h,0feh,0c6h,8ch,18h,30h,60h,0c2h,0c6h,0feh,0,0,0     ; 74: "Z" s rkou
db        0,0ch,18h,30h,0,0feh,0cch,18h,30h,66h,0feh,0,0,0           ; 75: "z" s rkou
db        66h,3ch,0feh,0c6h,8ch,18h,30h,60h,0c2h,0c6h,0feh,0,0,0     ; 76: "" s hkem
db        0,0,0cch,78h,0,0feh,0cch,18h,30h,66h,0feh,0,0,0            ; 77: "" s hkem
db        18h,18h,0feh,0c6h,8ch,18h,30h,60h,0c2h,0c6h,0feh,0,0,0     ; 78: "Z" s tekou
db        0,0,30h,30h,0,0feh,0cch,18h,30h,66h,0feh,0,0,0             ; 79: "z" s tekou
db        0,0,7ch,0c6h,60h,38h,6ch,0c6h,6ch,38h,0ch,0c6h,7ch,0       ; 80: "" paragraf
db        0,0,0,0,0,0c6h,6ch,38h,38h,6ch,0c6h,0,0,0                  ; 81: "x" pekrtnut
db        0,0,0,0c6h,0c6h,7ch,6ch,7ch,0c6h,0c6h,0,0,0,0              ; 82: "x" x s drou
db        0,0ch,18h,30h,0,0,0,0,0,0,0,0,0,0                          ; 83: "'" rka vpravo
db        0,0,0,0,0,0,0f0h,0,0,0,0,0,0,0                             ; 84: "-" krtk pomlka
db        0,0,066h,0cch,0,0,0,0,0,0,0,0,0,0                          ; 85: " 2 rky
db        0,0,0,0,0,0,0,0,0,0,10h,10h,1ch,0                          ; 86: patika
db        0,6ch,38h,10h,0,0,0,0,0,0,0,0,0,0                          ; 87: hek
db        0,066h,3ch,0,0,0,0,0,0,0,0,0,0,0                           ; 88: miska
db        0,0,0,0,0,0,0,0,0,0,0,18h,0ch,38h                          ; 89: ocsek
db        0,0,66h,66h,0,0,0,0,0,0,0,0,0,0                            ; 91: "" pehlasovn


font16   label     byte

db 6,0ch,10h,38h,6Ch,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,0,0,0,0      ; 0: "" s rkou
db 0c6h,7ch,10h,38h,6Ch,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,0,0,0,0   ; 2: "A" s hkem
db 0,0,0c6h,7ch,0,78h,0Ch,7Ch,0CCh,0CCh,0CCh,76h,0,0,0,0             ; 3: "a" s hkem
db 7ch,0c6h,10h,38h,6Ch,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0C6h,0,0,0,0   ; 6: "A" se stkou
db 0,0,10h,38h,6Ch,0C6h,0C6h,0FEh,0C6h,0C6h,0C6h,0Ceh,8,0eh,0,0      ; 8: "A" s noikou
db 0,0,0,0,0,78h,0Ch,7Ch,0CCh,0CCh,0CCh,76h,10h,1ch,0,0              ; 9: "a" s noikou
db 6,0ch,3Ch,66h,0C2h,0C0h,0C0h,0C0h,0C0h,0C2h,66h,3Ch,0,0,0,0       ; 10: "C" s rkou
db 0,0ch,18h,30h,0,7Ch,0C6h,0C0h,0C0h,0C0h,0C6h,7Ch,0,0,0,0          ; 11: "c" s rkou
db 66h,3ch,3ch,66h,0c2h,0c0h,0C0h,0C0h,0C0h,0C2h,66h,3Ch,0,0,0,0     ; 12: "" s hkem
db 0,66h,3ch,18h,0,7Ch,0C6h,0C0h,0C0h,0C0h,0C6h,7Ch,0,0,0,0          ; 13: "" s hkem
db 0cch,78h,0F8h,6Ch,66h,66h,66h,66h,66h,66h,6Ch,0F8h,0,0,0,0        ; 16: "" s hkem
db 66h,3ch,0,1Ch,0Ch,3Ch,6Ch,0CCh,0CCh,0CCh,0CCh,76h,0,0,0,0         ; 17: "" s hkem
db 0,0,0F8h,6Ch,66h,66h,76h,0e6h,66h,66h,6Ch,0F8h,0,0,0,0            ; 18: "D" pekrnut
db 0,0,0Ch,1eh,0Ch,3Ch,6Ch,0CCh,0CCh,0CCh,0CCh,76h,0,0,0,0           ; 19: "d" pekrtnut
db 0ch,18h,0FEh,66h,62h,68h,78h,68h,60h,62h,66h,0FEh,0,0,0,0         ; 20: "" s rkou
db 66h,3ch,0FEh,66h,62h,68h,78h,68h,60h,62h,66h,0FEh,0,0,0,0         ; 22: "" s hkem
db 0,66h,3ch,18h,0,7Ch,0C6h,0FEh,0C0h,0C0h,0C6h,7Ch,0,0,0,0          ; 23: "" s hkem
db 0c6h,0,0FEh,66h,62h,68h,78h,68h,60h,62h,66h,0FEh,0,0,0,0          ; 24: "E" pehlasovan
db 0,0,0FEh,66h,62h,68h,78h,68h,60h,62h,66h,0FEh,10h,1ch,0,0         ; 26: "E" s noikou
db 0,0,0,0,0,7Ch,0C6h,0FEh,0C0h,0C0h,0C6h,7Ch,10h,1ch,0,0            ; 27: "e" s noikou
db 0ch,18h,0,3ch,18h,18h,18h,18h,18h,18h,18h,3Ch,0,0,0,0             ; 28: "" s rkou
db 7eh,0c3h,3Ch,18h,18h,18h,18h,18h,18h,18h,18h,3Ch,0,0,0,0          ; 30: "I" se stkou
db 0,18h,3Ch,66h,0,38h,18h,18h,18h,18h,18h,3Ch,0,0,0,0               ; 31: "i" se stkou
db 6,6,0F4h,60h,60h,60h,60h,60h,60h,62h,66h,0FEh,0,0,0,0             ; 32: "" s rkou
db 3,3,72h,30h,30h,30h,30h,30h,30h,30h,30h,78h,0,0,0,0               ; 33: "" s rkou
db 1bh,0eh,0F4h,60h,60h,60h,60h,60h,60h,62h,66h,0FEh,0,0,0,0         ; 34: "" s hkem
db 33h,1eh,70h,30h,30h,30h,30h,30h,30h,30h,30h,78h,0,0,0,0           ; 35: "" s hkem
db 0,0,0F0h,60h,60h,60h,70h,0e0h,60h,62h,66h,0FEh,0,0,0,0            ; 36: "L" pekrtnut
db 0,0,38h,18h,18h,18h,1ch,38h,18h,18h,18h,3Ch,0,0,0,0               ; 37: "l" pektnut
db 0ch,18h,0c6h,0E6h,0F6h,0FEh,0DEh,0CEh,0C6h,0C6h,0C6h,0C6h,0,0,0,0 ; 38: "N" s rkou
db 0,6,0ch,18h,0,0DCh,66h,66h,66h,66h,66h,66h,0,0,0,0                ; 39: "n" s rkou
db 6ch,38h,0c6h,0E6h,0F6h,0FEh,0DEh,0CEh,0C6h,0C6h,0C6h,0C6h,0,0,0,0 ; 40: "" s hkem
db 0,66h,3ch,18h,0,0DCh,66h,66h,66h,66h,66h,66h,0,0,0,0              ; 41: "" s hkem
db 0ch,18h,0,7ch,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,7Ch,0,0,0,0      ; 42: "" s rkou
db 7ch,0c6h,0,7ch,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,7Ch,0,0,0,0     ; 44: "" se stkou
db 66h,0cch,0,7ch,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,7Ch,0,0,0,0     ; 48: "O" se 2 rkami
db 0,66h,0cch,0,0,7Ch,0C6h,0C6h,0C6h,0C6h,0C6h,7Ch,0,0,0,0           ; 49: "o" se 2 rkami
db 0ch,18h,0FCh,66h,66h,66h,7Ch,6Ch,66h,66h,66h,0E6h,0,0,0,0         ; 50: "" s rkou
db 0,6,0ch,18h,0,0DCh,76h,66h,60h,60h,60h,0F0h,0,0,0,0               ; 51: "" s rkou
db 0cch,78h,0FCh,66h,66h,66h,7Ch,6Ch,66h,66h,66h,0E6h,0,0,0,0        ; 52: "" s hkem
db 0,66h,3ch,18h,0,0DCh,76h,66h,60h,60h,60h,0F0h,0,0,0,0             ; 53: "" s hkem
db 0ch,18h,7Ch,0C6h,0C6h,60h,38h,0Ch,6,0C6h,0C6h,7Ch,0,0,0,0         ; 54: "S" s rkou
db 0,6,0ch,18h,0,7Ch,0C6h,60h,38h,0Ch,0C6h,7Ch,0,0,0,0               ; 55: "s" s rkou
db 66h,3ch,7Ch,0C6h,0C6h,60h,38h,0Ch,6,0C6h,0C6h,7Ch,0,0,0,0         ; 56: "" s hkem
db 0,66h,3ch,18h,0,7Ch,0C6h,60h,38h,0Ch,0C6h,7Ch,0,0,0,0             ; 57: "" s hkem
db 0,0,7Ch,0C6h,0C6h,60h,38h,0Ch,6,0C6h,0C6h,7Ch,18h,0ch,78h,0       ; 58: "S" s ocskem
db 0,0,0,0,0,7Ch,0C6h,60h,38h,0Ch,0C6h,7Ch,18h,0ch,78h,0             ; 59: "s" s ocskem
db 66h,3ch,7Eh,7Eh,5Ah,18h,18h,18h,18h,18h,18h,3Ch,0,0,0,0           ; 62: "T" s hkem
db 1bh,0eh,14h,30h,30h,0FCh,30h,30h,30h,30h,36h,1Ch,0,0,0,0          ; 61: "t" s hkem
db 0,0,7Eh,7Eh,5Ah,18h,18h,18h,18h,18h,18h,3Ch,18h,0ch,78h,0         ; 62: "T" s ocskem
db 0,0,10h,30h,30h,0FCh,30h,30h,30h,30h,36h,1Ch,18h,0ch,78h,0        ; 63: "t" s ocskem
db 0ch,18h,0,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,7Ch,0,0,0,0     ; 64: "" s rkou
db 38h,6ch,38h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,7Ch,0,0,0,0   ; 66: "" s kroukem
db 0,38h,6ch,38h,0,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,76h,0,0,0,0         ; 67: "" s kroukem
db 63h,0c6h,0,0C6h,0c6h,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,7Ch,0,0,0,0    ; 70: "U" se 2 rkami
db 0,33h,66h,0cch,0,0CCh,0CCh,0CCh,0CCh,0CCh,0CCh,76h,0,0,0,0        ; 71: "u" se 2 rkami
db 0ch,18h,66h,66h,66h,66h,3Ch,18h,18h,18h,18h,3Ch,0,0,0,0           ; 72: "" s rkou
db 0,6,0ch,18h,0,0C6h,0C6h,0C6h,0C6h,0C6h,0C6h,7Eh,6,0Ch,0F8h,0      ; 73: "" s rkou
db 0ch,18h,0FEh,0C6h,86h,0Ch,18h,30h,60h,0C2h,0C6h,0FEh,0,0,0,0      ; 74: "Z" s rkou
db 0,6,0ch,18h,0,0FEh,0CCh,18h,30h,60h,0C6h,0FEh,0,0,0,0             ; 75: "z" s rkou
db 0cch,78h,0FEh,0C6h,86h,0Ch,18h,30h,60h,0C2h,0C6h,0FEh,0,0,0,0     ; 76: "" s hkem
db 0,66h,3ch,18h,0,0FEh,0CCh,18h,30h,60h,0C6h,0FEh,0,0,0,0           ; 77: "" s hkem
db 18h,18h,0FEh,0C6h,86h,0Ch,18h,30h,60h,0C2h,0C6h,0FEh,0,0,0,0      ; 78: "Z" s tekou
db 0,0,18h,18h,0,0FEh,0CCh,18h,30h,60h,0C6h,0FEh,0,0,0,0             ; 79: "z" s tekou
db 0,7Ch,0C6h,60h,38h,6Ch,0C6h,0C6h,6Ch,38h,0Ch,0C6h,7Ch,0,0,0       ; 80: "" paragraf
db 0,0,0,0c6h,0c6h,6ch,6Ch,38h,38h,6Ch,6ch,0c6h,0c6h,0,0,0           ; 81: "x" pekrtnut
db 0,0,0,0c6h,0c6h,7ch,6ch,7ch,0c6h,0c6h,0,0,0,0,0,0                 ; 82: "x" x s drou
db 0,6,0ch,18h,0,0,0,0,0,0,0,0,0,0,0,0                               ; 83: "'" rka vpravo
db 0,0,0,0,0,3ch,0,0,0,0,0,0,0,0,0,0                                 ; 84: "-" krtk pomlka
db 0,33h,66h,0cch,0,0,0,0,0,0,0,0,0,0,0,0                            ; 85: " 2 rky
db 0,0,0,0,0,0,0,0,0,0,0,10h,10h,1ch,0,0                             ; 86: patika
db 0,0cch,78h,30h,0,0,0,0,0,0,0,0,0,0,0,0                            ; 87: hek
db 0,0c6h,7ch,0,0,0,0,0,0,0,0,0,0,0,0,0                              ; 88: miska
db 0,0,0,0,0,0,0,0,0,0,0,0,18h,0ch,78h,0                             ; 89: ocsek
db 0,0c6h,0c6h,0,0,0,0,0,0,0,0,0,0,0,0,0                             ; 91: "" pehlasovn


endrez   label     near                     ; konec rezidentn sti

; *****************************************************************************
;                         Instalace programu
; *****************************************************************************

errtxt   db        'Neni nainstalovana karta EGA/VGA !',13,10,'$'

help     db        'CS fonty EGA/VGA: /K=kod Kamenickych, /L=Latin 2, '
         db        '/0=IBM, /!=odinstalovani',13,10,'$'

ditxt1   db        'EGACS byl odinstalovan z pameti.',13,10,'$'
ditxt2   db        'EGACS nebyl dosud nainstalovan !',13,10,'$'
ditxt3   db        'EGACS nelze odinstalovat - odinstalujte',13,10
         db        'nejdrive programy nainstalovane po nem !',13,10,'$'


                                          ;* detekce fontu
                                            ; VSTUP: ES:DI=ukldac adresa
                                            ;        BH=sluba ke zjitn ukaz.
detfont: push      di
         push      es
         mov       ax,1130h
         int       10h                      ; informace o fontech
         mov       ax,es                    ; segment font
         pop       es
         pop       di

         add       di,3
         xchg      ax,bp
         stosw                              ; uloen offsetu adresy
         xchg      ax,bp
         stosw                              ; uloen segmentu adresy
         ret


TestVGA:                                  ;* test karty VGA
                                            ; VSTUP: CY=nen karta VGA
         mov       ax,1a00h
         int       10h                      ; dotaz na poet linek na znak
         cmp       al,1ah                   ; je funkce obsluhovan ?
         jne       DetCardH                 ; funkce nen obsluhovan
         cmp       bl,7                     ; je 7 linek na znak ?
         je        DetCardC                 ; je karta VGA
         cmp       bl,8
         je        DetCardC                 ; je karta VGA
DetCardH:                                 ;* nen karta VGA
         push      es
         mov       bx,0c000h                ; segment s ROM VGA
         mov       es,bx                    ; segment s ROM VGA
         mov       bx,39h                   ; adresa textu "Z449"
         cmp       word ptr es:[bx],"Z4"    ; je text "Z4" ?
         jne       DetCardD                 ; nen karta VGA
         cmp       word ptr es:[bx+2],"49"  ; je text "49" ?
DetCardD:pop       es
         je        DetCardC                 ; je karta VGA
         stc
DetCardC:ret

; -----------------------------------------------------------------------------
;        odinstalovn
; -----------------------------------------------------------------------------

; ------ test, zda je nainstalovn

dinstal: mov       dx,offset ditxt2
         mov       ax,cs
         mov       bp,es
         cmp       ax,bp                    ; je nainstalovn ?
         je        navrat                   ; nebyl nainstalovn

; ------ test vektoru peruen

         push      es
         mov       ax,3510h
         int       21h                      ; poskytnu adresy INT 10h
         mov       ax,es
         pop       es
         mov       dx,offset ditxt3
         cmp       ax,bp                    ; je posledn ?
         jne       navrat                   ; nelze odinstalovat

; ------ odinstalovn

         push      ds
         lds       dx,es:[Old10]            ; pvodn vektor peruen
         mov       ax,2510h
         int       21h                      ; nvrat vektoru peruen
         pop       ds

; ------ zruen pamovho bloku

         mov       ah,49h
         int       21h                      ; uvolnn alokanho bloku pamti

; ------ hlen o odinstalovn

         mov       dx,offset ditxt1
         jmp       short navrat             ; hlen o odinstalovn



public   instal
instal:
                                          ;* test, zda je karta EGA/VGA
         mov       ah,12h
         mov       bl,10h
         int       10h
         jc        error                    ; nen displej EGA/VGA
         cmp       bl,10h
         jne       instal1                  ; je displej EGA/VGA

                                          ;* chyba - nen karta EGA/VGA
error:   lea       dx,[errtxt]              ; chyba - nen karta EGA/VGA
navrat:  mov       ah,9
         int       21h
         int       20h

                                          ;* kontrola, zda je ji nainstalovn
instal1: mov       ax,1130h
         mov       bx,5678h
         int       10h                      ; dotaz na rezidentn instalaci
         mov       si,offset identtop       ; zatek identifikace
         mov       di,si
         mov       cx,offset(identend-identtop) ; dlka identifikace
         cld
         repe      cmpsb                    ; porovnn identifikan sti
         je        instal2                  ; je nainstalovn
         push      cs
         pop       es                       ; nen nainstalovn

                                          ;* rozkdovn zadn
instal2: push      cs
         pop       ds
         mov       dx,offset help           ; npovda
         mov       si,81h                   ; zatek textu
         xor       cx,cx
         mov       cl,ds:[80h]              ; poet znak zadn
instal3: jcxz      instal6
         lodsb                              ; naten dalho znaku
         dec       cx                       ; snen tae znak
         cmp       al," "                   ; oddlovac znak ?
         jbe       instal3                  ; je oddlovac znak
         cmp       al,"/"                   ; je parametr ?
         je        instal3                  ; oddlova parametru
         or        al,20h                   ; pevod na mal psmeno
         cmp       al,"k"                   ; kd Kamenickch ?
         jne       instal4                  ; nen kd Kamenickch
         mov       byte ptr es:[font],0     ; kd Kamenickch
         jmp       short instal3            ; dal znak
instal4: cmp       al,"l"                   ; kd Latin 2 ?
         jne       instal5                  ; nen kd Latin 2
         mov       byte ptr es:[font],1     ; kd Latin 2
         jmp       short instal3            ; dal znak
instal5: cmp       al,"0"                   ; vypnut obsluhy ?
         jne       instal52
         mov       byte ptr es:[font],-1    ; standardn kd IBM
         jmp       short instal3            ; dal znak
instal52:cmp       al,"!"                   ; odinstalovn ?
         jne       navrat                   ; chyba zadn
         jmp       dinstal                  ; odinstalovn


instal6:                                  ;* je to prvn instalace programu ?
         mov       ax,es
         mov       bx,cs
         cmp       ax,bx                    ; je program nainstalovan ?
         je        instal7                  ; nen jet nainstalovan

         mov       bp,offset instaluj
         call      inform                   ; zobrazen informanho textu
         int       20h                      ; konec programu

                                          ;* zjitn adres systmovch font
instal7:
         mov       di,offset fonty+1-3      ; adresy systmovch font
         mov       bh,3                     ; fonty 8x8
         call      detfont                  ; detekce fontu 8x8
         mov       bh,2                     ; fonty 8x14
         call      detfont                  ; detekce fontu 8x14

         push      es
         push      di
         call      testvga                  ; je karta VGA ?
         pop       di
         pop       es
         jc        instalc                  ; nen karta VGA
                                          ;* je karta VGA
         mov       bh,6                     ; fonty 8x16
         call      detfont                  ; detekce fontu 8x16
         mov       dx,offset endrez + 256*16 ; konec pro VGA kartu
         mov       bx,offset endrez         ; zatek bufferu pro VGA kartu
         jmp       short instalb
                                          ;* nen karta VGA
instalc: mov       dx,offset font16 + 256*14 ; konec pro EGA kartu
         mov       bx,offset font16         ; zatek bufferu pro EGA kartu
         mov       byte ptr cs:[tabfnt16],0 ; zruen fontu 8x16

instalb: mov       cs:[adrbuff],bx          ; nastaven adresy zatku bufferu

                                          ;* je poteba pesouvat ?
         lea       bp,[instaluj]            ; star zatek instalan sti
         cmp       bp,dx                    ; je konec pod instalan st ?
         jnb       instaluj                 ; nen teba pesouvat

                                          ;* je dost msta ?
         mov       di,dx
         add       di,(koneci-instaluj)+512 ; nov konec programu s rezervou
         cmp       sp,di                    ; je dost msta v pamti ?
         jb        instaluj                 ; v pamti nen dost msta

                                          ;* pesun se provede
         push      cs
         pop       es
         mov       bp,dx                    ; konec rezidentn sti
         add       bp,16+15+4               ; nov zatek programu
         mov       si,offset koneci-1       ; star konec programu
         lea       di,[bp+(koneci-instaluj)-1]; nov konec programu
         mov       cx,offset(koneci-instaluj) ; dlka programu
         std                                ; smr nahoru
         rep       movsb                    ; penesen programu nahoru
         cld                                ; nvrat smru
         clc                                ; pznak - pesun OK
         push      bp                       ; startovac adresa
         ret                                ; skok do programu

; -------------------------- instalan st programu -------------------------

public   instaluj
instaluj:                                 ;* instalace obsluh peruen
         pushf
         push      dx
         mov       ax,3510h
         int       21h
         mov       word ptr ds:[old10],bx
         mov       word ptr ds:[old10+2],es
         mov       dx,offset int10
         mov       ax,2510h
         int       21h
         pop       dx

         mov       es,ds:[2ch]              ; prosted
         mov       ah,49h
         int       21h                      ; uvolnn segmentu prosted

         push      cs
         pop       es
         popf
         jc        instali                  ; instalace bez inicializace



         push      dx                       ; konec rezidentn sti
         call      inform
         pop       dx
instali: int       27h                      ; instalace programu



inform:                                   ;* zobrazen informace o fontech


                                          ;* schova pozice kurzoru
         push      bp
         push      es
         mov       ah,0fh
         int       10h                      ; dotaz na souasn videomd
         push      ax                       ; schova videomdu
         mov       ah,3
         int       10h                      ; poskytnut pozice kurzoru
         pop       ax                       ; nvrat aktivnho videomdu
         push      dx                       ; schova pozice kurzoru
                                          ;* pedefinovn videomdu
         or        al,80h                   ; displej se nemae
         xor       ah,ah
         int       10h                      ; nov nastaven videomdu
                                          ;* zruen pznaku mazn displeje
         push      ds
         xor       ax,ax
         mov       ds,ax
         and       byte ptr ds:[449h],not 80h ; zruen pznaku nemazat displej
         and       byte ptr ds:[487h],not 80h ; zruen pznaku nemazat displej
         pop       ds
                                          ;* nvrat pozice kurzoru
         pop       dx                       ; nvrat pozice kurzoru
         mov       ah,2
         int       10h                      ; nvrat pozice kurzoru
         pop       es
         pop       bp


         lea       dx,[bp+(uvtxt-instaluj)] ; prvn st textu
         mov       ah,9
         int       21h                      ; zobrazen prvn sti textu
         lea       dx,[bp+(uvtxtk-instaluj)]; etina Kamenickch
         cmp       byte ptr es:[font],0     ; je etina Kamenickch ?
         je        inform2                  ; etina Kamenickch
         lea       dx,[bp+(uvtxtl-instaluj)]; etina Latin 2
         cmp       byte ptr es:[font],1     ; je etina Latin 2 ?
         je        inform2                  ; je etina Latin 2
         lea       dx,[bp+(uvtxt0-instaluj)]; etina vypnuta
inform2: mov       ah,9
         int       21h                      ; zobrazen druh sti textu
         ret

uvtxt    db        'EGACS V2.10 - CS fonty, kd $'

uvtxtk   db        'Kamenickch; (c) Miroslav Nmeek',13,10,'$'
uvtxtl   db        'Latin 2; (c) Miroslav Nmeek',13,10,'$'
uvtxt0   db        'IBM; (c) Miroslav Nemecek',13,10,'$'

koneci:                                   ;* konec instalace

code     ends
         end       start
